#include <Arduino.h> 
#include "hardware/pwm.h"
#include "PWM_Status.h"

class Stellmotor {
  private:
    uint           _MotorAuf;                                            // 
    uint           _MotorZu;
    uint           _RT_Regler;
    uint           _Feedback;
    PWM_Status     _StatusLED;
    const int      _sensorMax =          630;
    const int      _sensorMin =           60;        // Maximalwert vom Raumthemperaturregler 0...3,85V über Spannungsteiler 330/220 = 2,27V (0...680), gemessen 55 bis 680
    const int      _Feedback_delta_auf = 300;
    const int      _Feedback_delta_zu  = 250;        // Nur für Test mit ausgebautem Ventil hier niedrigerer Wert
    int            _Feedback_grenze_auf;             // Grenze unterhalb derer Motor auf Endanschlag ist
    int            _Feedback_grenze_zu;              // Für Test nur Feedback beim Aufmachen (Endanschlag im Motor)
    const int      _max_Fehler = 5;                  // Später ggf. noch erhöhen
    unsigned long  _verfahrzeit;                     // Zeit in ms zum ganz öffnen
    unsigned long  _stufenzeit;                      // Zeit in ms zum eine Stufe öffnen
    int            _sollwert;
    int            _istwert;                         // Werte zwischen 0-geschlossen und 9-voll geöffnet.
    int            _feedback;
    int            _sensorValue; 
    int            _fehlerzaehler;

    unsigned long kalibrieren();
    void verstellen();
    int verfahren(boolean richtung, unsigned long zeit_verfahr);
    unsigned long endanschlag(boolean richtung);
    int myMap(int x, int in_min, int in_max, int out_min, int out_max);  // Kopiert von /home/username/.arduino15/packages/rp2040/hardware/rp2040/2.6.3/ArduinoCore-API/api/common.cpp

  public:
    Stellmotor(const uint MotorAuf, const uint LED_MotorZu, const uint RT_Regler, 
                 const uint Feedback, const PWM_Status StatusLED );
    void init();                                                         // Muss da noch was zurückgegeben werden, falls nur ein Ventil angeschlossen ist?
    void init_mess();                                                                  
    void messen();
};
